.intel_syntax noprefix
.arch pentium
.altmacro
.include "macros.asm"

/************************************************************************/

// These will work without the .section directive, but without it the
// alignment directives will not work correctly in a .bss section.

.section .data

    fmt1: .asciz "%xh\n"
    fmt2: .asciz "Hello World!\n"

.section .bss

    .lcomm junk1, 4

.section .text

/************************************************************************/

.globl start
start:

    mov dword ptr junk1, 0x12345678

    cinvoke _printf offset(fmt1), offset(label1)
    cinvoke _printf offset(fmt1), data1

    cinvoke _printf offset(fmt1), offset(label2)
    cinvoke _printf offset(fmt1), data2

    cinvoke _printf offset(fmt1), offset(label3)
    cinvoke _printf offset(fmt1), data3

    cinvoke _printf offset(fmt1), junk1
    cinvoke _printf offset(fmt1), offset(junk1)

    invoke proc1

    jmp 0f

    data1: .int label1
    data2: .int label2
    data3: .int label3

  0:

  label1:
    nop
  label2:
    nop
  label3:

    cinvoke __getch
    cinvoke _exit, 0

/************************************************************************/

.align 16

  proc1:

    cinvoke _printf offset(fmt1), offset(proc1)

    call proc2

    ret

/************************************************************************/

.align 16

  proc2:

    cinvoke _printf offset(fmt1), offset(proc2)

    cinvoke _printf offset(fmt2)

    ret

/************************************************************************/